<?php
namespace App\Http\Controllers;
use App\Interfaces\ISections;
use Illuminate\Http\Request;

use App\Http\Requests;

//Import Traits
use App\Traits\User;

class MealsController extends ApiController implements ISections
{
use User;

    public function content(Request $request)
    {
        $validator = \Validator::make($request->all(), [
            'branch_id' => 'required',
            'categories' => 'required'
        ]);

        if ($validator->fails()) {
            return response()->json([
                'message' => $validator->messages()->first(),
                'status' => '400'], 400);
        }

        $token = $this->getUser()->company->token;
        $curlService = new \Ixudra\Curl\CurlService();
        $data = $curlService->to(env('BASE_URL').'meals_products')
            ->withHeader('token: '.$token)
            ->asJsonResponse()
            ->withData(
                [
                    'branch_id' => $request->branch_id,
                    'category_data' => json_encode($request->categories)
                ] )
            ->post();

        if(isset($data)){

            if($data){
                if($data->status == 1){
                    return response()->json(
                        [
                            'message' => $data->message,
                            'data' => $data->data->data,
                            'status' => '200'],
                        200);
                }else if($data->status == 0){
                    return response()->json(
                        [
                            'message' => $data->message,
                            'data' => [],
                            'status' => '400'],
                        200);
                }
            }
        }else{
            return response()->json(
                [
                    'message' => 'Failed to retrive data. Try again.',
                    'data' => [],
                    'status' => '400'],
                400);
        }

    }

}