<?php

namespace App\Traits;

trait Email {

    private function getCurrency($company_id){
        $currency = \App\Setting::where('company_id', $company_id)->select('name', 'rate', 'currency', 'is_currency_fixed')->first();
        return $currency;
    }

    public function sendStatusChangeEmail($status, $token, $payload){

        $endpoint = '';

        if($status == 2){
            $endpoint = env('RB_URL')."notification&note=shipped";
        }else if($status == 3){
            $endpoint = env('RB_URL')."notification&note=delivered";
        }
        else if($status == 8){
                    $endpoint = env('RB_URL')."notification&note=picked";
        } else if($status == 0){
           $endpoint = env('RB_URL')."notification&note=cancelled";
         }else if($status == 5){
           $endpoint = env('RB_URL')."notification&note=expired";
         }

        $curlService = new \Ixudra\Curl\CurlService();

        $data = $curlService->to($endpoint)
            ->withHeader('token: '.$token)
            ->withData($payload)
            ->asJsonResponse()
            ->post();

        if($data) {
            if (!isset($data)) {
                return "Error sending email";
            } else if ($data->status == 0) {
                return $data->message;
            }
            return $data->message;
        }else{
            return "Error sending email";
        }
    }

    public function sendStatusExpireEmail_7($token, $payload){
        $endpoint = env('RB_URL')."notification&note=7day_expire";
        $curlService = new \Ixudra\Curl\CurlService();

        $data = $curlService->to($endpoint)
            ->withHeader('token: '.$token)
            ->withData($payload)
            ->asJsonResponse()
            ->post();

        if($data) {
            if (!isset($data)) {
                return "Error sending email";
            } else if ($data->status == 0) {
                return $data->message;
            }
            return $data->message;
        }else{
            return "Error sending email";
        }
    }

    public function sendStatusExpireEmail_2( $token, $payload){
        $endpoint = env('RB_URL')."notification&note=2day_expire";
        $curlService = new \Ixudra\Curl\CurlService();

        $data = $curlService->to($endpoint)
            ->withHeader('token: '.$token)
            ->withData($payload)
            ->asJsonResponse()
            ->post();

        if($data) {
            if (!isset($data)) {
                return "Error sending email";
            } else if ($data->status == 0) {
                return $data->message;
            }
            return $data->message;
        }else{
            return "Error sending email";
        }
    }


public function buildTable($data, $address, $oderno){

    $shipaddress = $address != null ? $address : false;
    $date = date("Y/m/d");
    $table = "<table style=' width: 500px; border-bottom: 2px solid #000;' >";
    $table .= "<tr style='border-bottom: 2px solid #000;'>";
    $table .="<td style='padding: 20px 0px;'><p><b>Order No: </b> <span>{$oderno}</span></p><p><b>Date: </b> <span>{$date}</span></p></td>";
    $table .="</tr>";
    //$table .="<div style='width:100%;background-color: #000; height: 2px;'></div>";

    if($shipaddress){


        $table .= "<tr>";
        $table .= "<td colspan='5' style='border-top: 2px solid #000;border-bottom: 1px solid #000; margin: 0px; padding: 10px  0px; margin-bottom: 10px'>";
        $table .= "<p style='padding-top: 10px;'><b>Delivery Address:</b>". $shipaddress."</p>";

        $table .= "</tr>";
    }
    $table .= "<tr style='border-bottom: 1px solid #000'>";
    $table .= "<td colspan='4' style='border-bottom: 1px solid #000; padding: 10px  0px;'><b>Item Description</b></td>";
    $table .= "<td colspan='4' style='text-align: right; border-bottom: 1px solid #000; padding: 10px  0px;'><b>Price</b></td>";
    $table .= "</tr>";
    foreach ($data as $item) {
        if($item['delivery_type'] == 2) {
            $table .= "<tr>";
            $table .= "<td colspan='4' style='border-bottom: 1px solid #ccc;'>";
            $table .= "<p style='padding-top: 10px;'><b>Delivery Type: </b><span style='margin-right: 5px;'>" . $item['delivery_type_name'] . "</span></p>";

            $table .= "<p style='padding-top: 2px;'>" . $item['name']. " ";

            $table .= "</p>";
            $table .= "<p style='padding-bottom: 10px;'><b>Qty: </b><span style='margin-right: 5px;'>" . $item['quantity'] . "</span><b>Voucher: </b><span style='margin-right: 5px;'>" . $item['voucher'] . "</span></p>";

            $table .= "</td>";
            $table .= "<td colspan='4' style='text-align: right; border-bottom: 1px solid #ccc;'><p>{$item['virtual_price']}</p></td>";
            $table .= "</tr>";
        }else if ($item['delivery_type'] == 1){
            $table .= "<tr>";
            $table .= "<td colspan='4' style='border-bottom: 1px solid #ccc;'>";
            $table .= "<p style='padding-top: 10px;'><b>Delivery Type: </b><span style='margin-right: 5px;'>" . $item['delivery_type_name'] . "</span></p>";
            $table .= "<p style='padding-top: 2px;'>" . $item['name']. " ";

            $table .= "</p>";
            $table .= "<p><b>Qty: </b><span style='margin-right: 5px;'>" . $item['quantity'] . "</span><b>Voucher: </b><span style='margin-right: 5px;'>" . $item['voucher'] . "</span></p>";
            $table .= "<p style='padding-bottom: 10px;'><b>Pickup Location: </b>" . $item['pickup_location_name'] . "</p>";

            $table .= "</td>";
            $table .= "<td colspan='4' style='text-align: right; border-bottom: 1px solid #ccc;'><p>{$item['virtual_price']}</p></td>";
            $table .= "</tr>";
        }
    }


    $table .= "</table>";
    return $table;

}

// public function buildTable_old($data, $address, $oderno)
// {

//     $shipaddress = $address != null ? $address : false;
//     $date = date("Y/m/d");
//     $table = "<table border='1' style='border-collapse: collapse; width: 500px; padding: 10px;' >";
//     $table .= "<thead>";
//     $table .= "<th></th>";
//     $table .= "<th style='border-right: none; padding: 10px;'>Order No: {$oderno}</th>";
//     $table .= "<th colspan='4' style='border-left: none; padding: 10px;'></th>";
//     $table .= "</thead>";
//     $table .= "<tr>
//         <td style='padding: 10px;'><b>Date</b></td>
//         <td style='padding: 10px;'><b>Item Name</b></td>
//         <td style='padding: 10px;'><b>Voucher</b></td>
//         <td style='padding: 10px;'><b>Quantity</b></td>
//         <td style='padding: 10px;'><b>Price</b></td>
//         <td style='padding: 10px;'><b>Delivery Type</b></td>
//         </tr>";
//     foreach ($data as $item) {
//         $table .= "<tr>";
//         $table .= "<td style='padding: 10px; text-align: center'>".$date."</td>";
//         $table .= "<td style='padding: 10px; text-align: center'>".$item['name']."</td>";
//         $table .= "<td style='padding: 10px; text-align: center'>".$item['voucher']."</td>";
//         $table .= "<td style='padding: 10px; text-align: center'>".$item['quantity']."</td>";
//         $table .= "<td style='padding: 10px; text-align: center'>".$item['virtual_price']."</td>";
//         $table .= "<td style='padding: 10px; text-align: center'>".$item['delivery_type_name']."</td>";
//         $table .= "</tr>";
//     }
    
//     if($shipaddress){
//         $table .= " <tr>";
//         $table .= "<td colspan='6' style='border-bottom: none; padding: 10px'><b>Delivery Address</b></td>";
//         $table .= "</tr>";
//     }
    

//     if($shipaddress){
//         $table .= "<tr>";
//         $table .= "<td colspan='6' style='border-top: none; padding: 10px'>{$address}</td>";
//         $table .= "</tr>";
//     }

//     $table .= "</table>";
//     return $table;
// }

public function buildExpireTable($data, $address, $oderno)
{

    $shipaddress = $address != null ? $address : false;
    $date = date("Y/m/d");
    $table = "<table border='1' style='border-collapse: collapse; width: 100%; padding: 10px;' >";
    $table .= "<thead>";
    $table .= "<th colspan='2' style='padding: 10px;'><b>Date</b>: $date</th>";
    $table .= "<th colspan='2' style='border-right: none; padding: 10px;'>Order No: {$oderno}</th>";
    //$table .= "<th colspan='4' style='border-left: none; padding: 10px;'></th>";
    $table .= "</thead>";
    $table .= "<tr>
        
        <td style='padding: 10px;'><b>Item Name</b></td>
        <td style='padding: 10px;'><b>Quantity</b></td>
        <td style='padding: 10px;'><b>Price</b></td>
        <td style='padding: 10px;'><b>Branch</b></td>
        </tr>";
    foreach ($data as $item) {
        $table .= "<tr>";
       
        $table .= "<td style='padding: 10px; text-align: center'>".$item['name']."</td>";
        $table .= "<td style='padding: 10px; text-align: center'>".$item['quantity']."</td>";
        $table .= "<td style='padding: 10px; text-align: center'>".$item['virtual_price']."</td>";
        $table .= "<td style='padding: 10px; text-align: center'>".$item['pickup_location_name']."</td>";
        $table .= "</tr>";
    }
    $table .= " <tr>";
    // if($shipaddress){
    //     $table .= "<td colspan='5' style='border-bottom: none; padding: 10px'><b>Delivery Address</b></td>";
    // }
    // $table .= "</tr>";

    // if($shipaddress){
    //     $table .= "<tr>";
    //     $table .= "<td colspan='5' style='border-top: none; padding: 10px'>{$address->address}</td>";
    //     $table .= "</tr>";
    // }

    $table .= "</table>";
    return $table;
}

// public function buildSuccessDetails($data){
//         $filtered_vouchers = collect(($data))->map(function($item){
//             return $item->vouchers[0];
//         });


// $items = \App\Cart::whereIn('voucher', $filtered_vouchers)->select('name', 'qty', 'delivery_type', 'delivery_location', 'pickup_location_name', 'company_id', 'price', 'voucher')->get();
//     $details = [];

//     foreach ($items as $item){
//         $virtual_price = null;
//         $data = [];
//         if ($this->getCurrency($item->company_id)->is_currency_fixed == '1'){
//             $virtual_price ="&#8358 " .number_format(ceil($item->price * $item->qty), 0, '', ',');
//         }
//         else
//         {
//             $virtual_price = number_format(ceil($this->getCurrency($item->company_id)->rate * ($item->price * $item->qty)), 0, '', ',') . ' ' . $this->getCurrency($item->company_id)->currency;
//         }
//         $data['name'] = $item->name;
//         $data['quantity'] = $item->qty;
//         $data['voucher'] = $item->voucher;
//         $data['pickup_location_name'] = $item->pickup_location_name;
//         $data['delivery_type_name'] = $item->delivery_type == 1 ? 'Pickup' : 'Delivery';
//         $data['virtual_price'] = $virtual_price;
//         array_push($details, $data);
//     }
//     return $details;
// }

public function buildSuccessDetails($data){
        $filtered_vouchers = collect(($data))->map(function($item){
            return $item->vouchers[0];
        });


$items = \App\Cart::whereIn('voucher', $filtered_vouchers)->select('name', 'qty', 'delivery_type', 'delivery_location', 'pickup_location_name','company_id', 'price', 'voucher')->get();
    $details = [];

    foreach ($items as $item){
        $virtual_price = null;
        $data = [];
        if ($this->getCurrency($item->company_id)->is_currency_fixed == '1'){
            $virtual_price ="&#8358 " .number_format(ceil($item->price * $item->qty), 0, '', ',');
        }
        else
        {
            $virtual_price = number_format(ceil($this->getCurrency($item->company_id)->rate * ($item->price * $item->qty)), 0, '', ',') . ' ' . $this->getCurrency($item->company_id)->currency;
        }
        $data['name'] = $item->name;
        $data['quantity'] = $item->qty;
        $data['voucher'] = $item->voucher;
        $data['pickup_location_name'] = $item->pickup_location_name;
        $data['delivery_type_name'] = $item->delivery_type == 1 ? 'Pickup' : 'Delivery';
        $data['delivery_type'] = $item->delivery_type;
        $data['virtual_price'] = $virtual_price;
        array_push($details, $data);
    }
    return $details;
}

}